﻿local G, F, C, L = unpack(select(2,...))
local function TestFunc()
local _
if AddUIDB.cast ==  false  then return end

-------------------------------------
-- 系统施法条
-------------------------------------
local colorcastbar = "Interface\\Addons\\AddUI\\UI\\Textures\\colorbar.tga"
local function CreateFontString(self)
local parent = self:GetParent()
if self:IsForbidden() then return end
if self == PetCastingBarFrame then return end
    self.CooldownText = self:CreateFontString(nil)
    self.CooldownText:SetFont(SystemFont_Outline_Small:GetFont(), 16, "OUTLINE")	--施法时间文字大小
    self.CooldownText:SetWidth(100)
    self.CooldownText:SetJustifyH("RIGHT")
    self.CooldownText:SetPoint("TOP", self, "RIGHT", -46, 26)				--施法条时间位置
if parent.unit == 'target' or parent.unit == 'focus' then		--目标和焦点时间位置
	--self.CooldownText:SetJustifyH("LEFT")
	self.CooldownText:SetPoint("TOP", self, "RIGHT", -46, 24)				--施法条时间位置
end
    local fontFile, fontSize, fontFlags = self.Text:GetFont() 
    self.Text:SetFont(fontFile, fontSize- -2, fontFlags)				--施法条法术名称大小
end

--[[宠物施法条
PetCastingBarFrame.Icon:Show()   --fix@20160721
PetCastingBarFrame.Border:SetTexture(nil)
PetCastingBarFrame.Flash:SetTexture(nil)
PetCastingBarFrame.Spark:SetTexture(nil)
PetCastingBarFrame.Text:SetFont("fonts\\ARHei.ttf", 12, nil)
PetCastingBarFrame:SetSize(155,10)
PetCastingBarFrame:SetStatusBarTexture(.75,.75,.75)
PetCastingBarFrame:HookScript("OnValueChanged", function() 	PetCastingBarFrame:Show() end ); ]]

--自身施法条修改
CastingBarFrame:SetHeight(20)			--施法条高度
CastingBarFrame:SetWidth(260)			--施法条宽度
--CastingBarFrame.Spark:SetHeight(60)		--施法条闪光高度
CastingBarFrame.Spark:SetTexture(nil)	--施法条闪光
CastingBarFrame.Icon:Show()				--施法条图标显示
CastingBarFrame.Icon:SetSize(22,22)		--施法条图标大小
CastingBarFrame.Border:SetTexture(nil)
CastingBarFrame:SetFrameStrata("HIGH")	--施法条框架优先级
CastingBarFrame.Flash:SetTexture(nil)
if AddUIDB.castc ==  true  then
CastingBarFrame:SetStatusBarTexture(colorcastbar)
end


local function ShowCastingTimer(self, elapsed)
if self:IsForbidden() then return end
if self:GetName() == nil then return end

    if (not self.CooldownText) then
        CreateFontString(self)
        self.timer = 0
       if (self:GetName() == "CastingBarFrame") then
 --           self.Border:SetTexture("Interface\\CastingBar\\UI-CastingBar-Border-Small")
 --           self.Flash:SetTexture("Interface\\CastingBar\\UI-CastingBar-Flash-Small")
 --          self.Border:SetPoint("TOP", 0, 26)						--施法条外框体位置
            self.Text:SetPoint("TOP", 0, -1)						--施法条法术名称位置
 --           self.Icon:Show()
       end
    end
    self.timer = self.timer + elapsed
    if (self.timer > 0.1) then
        self.timer = 0
        if self.casting then
            self.CooldownText:SetText(format("%.1f/%.1f", max(self.value, 0), self.maxValue))						--当前时间/总时间
			--self.CooldownText:SetText(format("%.1f/%.1f", self.maxValue - max(self.value, 0), self.maxValue))		--剩余时间/总时间
        elseif self.channeling then
            self.CooldownText:SetText(format("%.1f", max(self.value, 0)))
        else
            self.CooldownText:SetText("")
        end
    end
end
hooksecurefunc("CastingBarFrame_OnUpdate", ShowCastingTimer)
if AddUIDB.castc ==  true  then
CastingBarFrame_SetStartCastColor(CastingBarFrame, 1, 1, 1)
CastingBarFrame_SetStartChannelColor(CastingBarFrame, 1, 1, 1)
CastingBarFrame_SetNonInterruptibleCastColor(CastingBarFrame, 1, 1, 1)
end

hooksecurefunc("CastingBarFrame_OnEvent", function(self, event, ...)
if self:IsForbidden() then return end
    if (not self.hasRegisterCastingTimer) then
        self.hasRegisterCastingTimer = true
        local func = self:GetScript("OnUpdate")
        if (func ~= CastingBarFrame_OnUpdate) then
            self:SetScript("OnUpdate", CastingBarFrame_OnUpdate)
        end
    end
end)

if (CastingBarFrame) then
    CastingBarFrame:HookScript("OnUpdate", ShowCastingTimer)
end

hooksecurefunc("MirrorTimerFrame_OnUpdate", function(self, elapsed)
if (self.paused) then return end
    if (not self.CooldownText) then
        self.CooldownText = self:CreateFontString(nil)
        self.CooldownText:SetFont(SystemFont_Outline_Small:GetFont(), 8, "OUTLINE")
        self.CooldownText:SetWidth(100)
        self.CooldownText:SetJustifyH("RIGHT")
        self.CooldownText:SetPoint("RIGHT", self, "RIGHT", -100, 6)
        self.itimer = 0
        _G[self:GetName().."Border"]:SetTexture("Interface\\CastingBar\\UI-CastingBar-Border-Small")
		
    end
    self.itimer = self.itimer + elapsed
    if (self.itimer > 0.5) then
        self.itimer = 0
        self.CooldownText:SetText(floor(self.value))
    end
end)

--[[施法延迟
local lagmeter = CastingBarFrame:CreateTexture(nil,"OVERLAYER"); 
lagmeter:SetHeight(CastingBarFrame:GetHeight()); 
lagmeter:SetWidth(0); 
lagmeter:SetPoint("RIGHT", CastingBarFrame, "RIGHT", 0, 0); 
lagmeter:SetTexture("Interface\\ChatFrame\\ChatFrameBackground"); 
lagmeter:SetVertexColor(1,0.3,0); -- red color 

hooksecurefunc(CastingBarFrame, "Show", function() 
   down, up, lag = GetNetStats(); 
   local castingmin, castingmax = CastingBarFrame:GetMinMaxValues(); 
   local lagvalue = ( lag / 1000 ) / ( castingmax - castingmin ); 
   
   if ( lagvalue < 0 ) then 
      lagvalue = 0; 
   elseif ( lagvalue > 1 ) then 
      lagvalue = 1; 
   end; 
   
   lagmeter:SetWidth(CastingBarFrame:GetWidth() * lagvalue); 
end);
--]]

end
G:RegisterEvent("PLAYER_LOGIN",TestFunc)